uk.ac.starlink.table.formats

## Class VerTableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.VerTableBuilder

- All Implemented Interfaces:
    MultiTableBuilder, TableBuilder

      public class VerTableBuilder
      extends java.lang.Object
      implements MultiTableBuilder

  Table builder for reading tables in the loosely-defined "ver" format. This is a family of more or less ad-hoc(?) ASCII-based formats for specifying the shapes of 3d bodies.

  There are usually two parts, which are read by this handler as two tables: a list of 3d vertices, and a list of polygons referencing these vertices. The first line contains two integers, for the vertex and face counts.

  At present, the vertices are represented as 3 columns X,Y,Z, and the plates must be triangular and are represented as an intial 3-element position followed by a 6-element array of "other" positions. This is just because those are in the form that's easy to plot using the plot2 * `polygon` layer. But there might be better ways to do this.

  This implementation is hacky, mainly because I don't have a robust definition of the format(s). It should and maybe could be improved. See MKDSK documentation referenced below.

  Some examples are:

  - DAMIT variant: example file
  - SBN (Gaskell?) format: example file
  - Comsim(?) variant: example file

  Resources:

  - Stephane Erard's confluence page (see section "Small body shape models"): here
  - MKDSK user guide here. This has a promising description of some other similar formats which a future evolution of this reader could be made to read.
  Since:
    6 Feb 2025

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `VerTableBuilder()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table.
    `boolean` | `canStream()` Currently returns false.
    `java.lang.String` | `getFormatName()` Returns the name of the format which can be read by this handler.
    `boolean` | `looksLikeFile(java.lang.String location)` Indicates whether the given location string is of a familiar form for this builder.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy storagePolicy)` Constructs a `StarTable` based on a given `DataSource`.
    `TableSequence` | `makeStarTables(DataSource datsrc, StoragePolicy policy)` Constructs a sequence of StarTables based on a given DataSource.
    `void` | `streamStarTable(java.io.InputStream in, TableSink sink, java.lang.String pos)` Reads a table from an input stream and writes it a row at a time to a sink.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### VerTableBuilder

          public VerTableBuilder()

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Description copied from interface: `TableBuilder`
      Returns the name of the format which can be read by this handler. Matching against this string may be used by callers to identify or select this handler from a list.
      Specified by:
        `getFormatName` in interface `TableBuilder`
      Returns:
        one-word description of this handler's format

    - #### looksLikeFile

          public boolean looksLikeFile(java.lang.String location)

      Description copied from interface: `TableBuilder`
      Indicates whether the given location string is of a familiar form for this builder. Implementations should return `true` if there is a good chance that a file with the given `location` can be interpreted by this reader, for instance if it has a suitable file extension.

      This method may be used to guess, on a best-efforts basis, whether this builder is suitable for reading a file from a given location. Attempts may still be made to read inputs for which this method returns false. It is less important for builders that can recognise files by magic number, which is generally preferable to using filenames.

      Specified by:
        `looksLikeFile` in interface `TableBuilder`
      Parameters:
        `location` - the location string, such as a filename or URL (not null)
      Returns:
        true iff there is a good chance that the named input can be interpreted by this reader

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Description copied from interface: `TableBuilder`
      Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table. It should return `true` if it thinks that its `TableBuilder.streamStarTable(java.io.InputStream, uk.ac.starlink.table.TableSink, java.lang.String)` method stands a reasonable chance of successfully constructing a `StarTable` from a `DataSource` whose input stream is described by the `DataFlavor` `flavor`. It will typically make this determination based on the flavor's MIME type.

      This method should only return `true` if the flavor looks like it is targeted at this builder; for instance a builder which uses a text-based format should return false for a flavor which indicates a MIME type of `text/plain`.

      This method is used in supporting drag and drop functionality (see `StarTableFactory.canImport(java.awt.datatransfer.DataFlavor[])`).

      Specified by:
        `canImport` in interface `TableBuilder`
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### canStream

          public boolean canStream()

      Currently returns false. This wouldn't be so hard to do, but it's not that useful since it can only return one table. Maybe do it at some point, but work out first what format variants we will support.

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream in,
                                      TableSink sink,
                                      java.lang.String pos)
                               throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

      The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

      Specified by:
        `streamStarTable` in interface `TableBuilder`
      Parameters:
        `in` - input stream containing table data
        `sink` - destination of the table
        `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed
        `java.io.IOException` - if some other error occurs

    - #### makeStarTables

          public TableSequence makeStarTables(DataSource datsrc,
                                              StoragePolicy policy)
                                       throws java.io.IOException

      Description copied from interface: `MultiTableBuilder`
      Constructs a sequence of StarTables based on a given DataSource. If the source is not recognised or this object does not know how to make tables from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      If the `position` of the data source is not null, then this method should return a sequence containing a single table, the one which would be returned by the `makeStarTable` method with that position.

      Specified by:
        `makeStarTables` in interface `MultiTableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `policy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        an array of StarTables read from `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy storagePolicy)
                                  throws java.io.IOException

      Description copied from interface: `TableBuilder`
      Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

      Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

      Specified by:
        `makeStarTable` in interface `TableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `wantRandom` - whether, preferentially, a random access table should be returned
        `storagePolicy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a StarTable made out of `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing